#include "StdAfx.h"
#include "DumpText.h"

CCriticalSection g_csDumpText;

CDumpText::CDumpText(void)
{
	//
	g_csDumpText.Lock();
	bContinue = true;
	g_csDumpText.Unlock();
	m_pDumpThread = AfxBeginThread(DumpMainFunc, this, THREAD_PRIORITY_NORMAL,0,CREATE_SUSPENDED,NULL);
	m_pDumpThread->m_bAutoDelete = FALSE;
}

CDumpText::~CDumpText(void)
{
	g_csDumpText.Lock();
	bContinue=false;
	g_csDumpText.Unlock();

	if(NULL != m_pDumpThread)
	{
		::WaitForSingleObject(m_pDumpThread->m_hThread,INFINITE);
		delete m_pDumpThread;
		m_pDumpThread = NULL;
	}
}

DTOption CDumpText::GetOption()
{
	return m_Option;
}

void CDumpText::SetOption(DTOption Option)
{
	m_Option = Option;
}

void CDumpText::PrintText(LPCSTR szText, int nCharset, bool bTranslated)
{
	wchar_t szTextW[4096]=L"\0";
	wchar_t szHexW[4096]=L"\0";
	MyMultiByteToWideChar(nCharset, 0, szText, -1, szTextW, 4096);

	//HexPrint
	int Len = (int)strlen(szText);
	int HexLen=0;
	for(int i=0;i<Len;i++)
	{
		if(IsDBCSLeadByteEx(nCharset,(BYTE)szText[i]))
		{
			//
			HexLen += swprintf_s(szHexW+HexLen,4096,L"%02X%02X ",(BYTE)szText[i],(BYTE)szText[i+1]);
			i++;
		}
		else
		{
			HexLen += swprintf_s(szHexW+HexLen,4096,L"%02X ",(BYTE)szText[i]);
			//ݰ
		}
	}

	TextSet TextTemp;
	TextTemp.strText=szTextW;
	TextTemp.strHex=szHexW;
	TextTemp.bTranslated=bTranslated;

	//â 尡  ưǷ ⿡ ó
	if(m_Option.WUse)
	{
		if((!TextTemp.bTranslated && m_Option.WJpnText) ||
			(TextTemp.bTranslated && m_Option.WKorText))
			m_pDumpDlg->PrintText(CString(TextTemp.strText.c_str()));

		if((!TextTemp.bTranslated && m_Option.WJpnHex) ||
			(TextTemp.bTranslated && m_Option.WKorHex))
			m_pDumpDlg->PrintText(CString(TextTemp.strHex.c_str()));
	}

	g_csDumpText.Lock();
	m_PrintQueue.push(TextTemp);
	g_csDumpText.Unlock();
}


//ʱȭ ۾
// ʱȭ ô´.
void CDumpText::Init()
{
	
}

void CDumpText::Start()
{

	m_pDumpThread->ResumeThread();
	m_pDumpDlg->Start();
}

void CDumpText::Stop()
{
	m_pDumpDlg->Stop();
	m_pDumpThread->SuspendThread();
	g_csDumpText.Lock();
	while(!m_PrintQueue.empty())
		m_PrintQueue.pop();
	g_csDumpText.Unlock();
}

UINT CDumpText::DumpMainFunc(LPVOID lpParam)
{
	CDumpText*  pDumpText = (CDumpText *) lpParam;
	FILE * pFile;
	_wfopen_s(&pFile,pDumpText->m_Option.FDest.c_str(),L"a,ccs=UTF-16LE");
	
	TextSet TextTemp, TextTemp2;
	bool inText=false;
	bool isClipSet=false;

	wstring strTemp;

	while(true)
		{
		Sleep(1);
		inText=false;

		g_csDumpText.Lock();
		if(FALSE == bContinue)
		{
			g_csDumpText.Unlock();
			break;
		}
		else
		{
			if(!pDumpText->m_PrintQueue.empty())
			{
				TextTemp2 = TextTemp;
				TextTemp  = pDumpText->m_PrintQueue.front();
				pDumpText->m_PrintQueue.pop();
				inText=true;
			}
			g_csDumpText.Unlock();

			if(inText)
			{
				//۾ 

				//  尡 Ƿ ⿡ ó 

				//
				if(pDumpText->m_Option.FUse && pFile)
				{
					if((!TextTemp.bTranslated && pDumpText->m_Option.FJpnText) ||
						(TextTemp.bTranslated && pDumpText->m_Option.FKorText))
						fwprintf(pFile,L"%s\n",TextTemp.strText.c_str());

					if((!TextTemp.bTranslated && pDumpText->m_Option.FJpnHex) ||
						(TextTemp.bTranslated && pDumpText->m_Option.FKorHex))
						fwprintf(pFile,L"%s\n",TextTemp.strHex.c_str());
				}

				//Ŭ
				if(pDumpText->m_Option.CUse)
				{
					isClipSet=false;
					strTemp.clear();

					if(pDumpText->m_Option.CPack&&TextTemp.bTranslated)
					{
						//TextTemp2 Ϻ
						//TextTemp  ѱ
						if(pDumpText->m_Option.CJpnText)
						{
							strTemp += TextTemp2.strText;
							strTemp += L"\r\n";
							isClipSet=true;
						}
						if(pDumpText->m_Option.CJpnHex)
						{
							strTemp += TextTemp2.strHex;
							strTemp += L"\r\n";
							isClipSet=true;
						}
						if(pDumpText->m_Option.CKorText)
						{
							strTemp += TextTemp.strText;
							strTemp += L"\r\n";
							isClipSet=true;
						}
						if(pDumpText->m_Option.CKorHex)
						{
							strTemp += TextTemp.strHex;
							strTemp += L"\r\n";
							isClipSet=true;
						}

					}
					else if(!pDumpText->m_Option.CPack)
					{
						if((!TextTemp.bTranslated && pDumpText->m_Option.FJpnText) ||
							(TextTemp.bTranslated && pDumpText->m_Option.FKorText))
						{
							strTemp += TextTemp.strText;
							strTemp += L"\r\n";
							isClipSet=true;
						}

						if((!TextTemp.bTranslated && pDumpText->m_Option.FJpnHex) ||
							(TextTemp.bTranslated && pDumpText->m_Option.FKorHex))
						{
							strTemp += TextTemp.strHex;
							strTemp += L"\r\n";
							isClipSet=true;
						}
					}

					if(isClipSet)
					{
						//ǵ \r\n 
						strTemp.erase(strTemp.length()-1);
						strTemp.erase(strTemp.length()-1);

						size_t uSize=(strTemp.length() + 1) * sizeof(wchar_t);
						HGLOBAL hGlobal = GlobalAlloc(GHND | GMEM_SHARE, uSize);

						LPWSTR pGlobal = (LPWSTR)GlobalLock(hGlobal);
						
						if(pGlobal)
						{
							wcscpy_s(pGlobal,uSize, strTemp.c_str());
							GlobalUnlock(hGlobal);

							OpenClipboard(NULL);
							EmptyClipboard();

							SetClipboardData(CF_UNICODETEXT, hGlobal);
							
							CloseClipboard();

							//GlobalFree(hGlobal);
						}
					}

				}//if CUse end
			}//if inText end
		}//if g_bContinue end
	}//while end

	if(pFile)
		fclose(pFile);
	return 0L;
}

void CDumpText::OpenOption()
{
	//ɼ 

	CFileOptionParser cOptionParser(L"ATData\\DumpText.dat");
	cOptionParser.OpenOptionFile();

	m_Option.WUse		= cOptionParser.GetOptionBool(L"W",1);
	m_Option.WJpnText	= cOptionParser.GetOptionBool(L"W",2);
	m_Option.WJpnHex	= cOptionParser.GetOptionBool(L"W",3);
	m_Option.WKorText	= cOptionParser.GetOptionBool(L"W",4);
	m_Option.WKorHex	= cOptionParser.GetOptionBool(L"W",5);

	m_Option.FUse		= cOptionParser.GetOptionBool(L"F",1);
	m_Option.FJpnText	= cOptionParser.GetOptionBool(L"F",2);
	m_Option.FJpnHex	= cOptionParser.GetOptionBool(L"F",3);
	m_Option.FKorText	= cOptionParser.GetOptionBool(L"F",4);
	m_Option.FKorHex	= cOptionParser.GetOptionBool(L"F",5);

	m_Option.CUse		= cOptionParser.GetOptionBool(L"C",1);
	m_Option.CJpnText	= cOptionParser.GetOptionBool(L"C",2);
	m_Option.CJpnHex	= cOptionParser.GetOptionBool(L"C",3);
	m_Option.CKorText	= cOptionParser.GetOptionBool(L"C",4);
	m_Option.CKorHex	= cOptionParser.GetOptionBool(L"C",5);

	m_Option.WNew		= cOptionParser.GetOptionBool(L"WNew");
	m_Option.WTop		= cOptionParser.GetOptionBool(L"WTop");

	m_Option.WFontFace	= cOptionParser.GetOptionString(L"WFontFace");

	m_Option.WFont_R	= cOptionParser.GetOptionBool(L"WFont",1);
	m_Option.WFont_G	= cOptionParser.GetOptionBool(L"WFont",2);
	m_Option.WFont_B	= cOptionParser.GetOptionBool(L"WFont",3);

	m_Option.WBack_R	= cOptionParser.GetOptionBool(L"WBack",1);
	m_Option.WBack_G	= cOptionParser.GetOptionBool(L"WBack",2);
	m_Option.WBack_B	= cOptionParser.GetOptionBool(L"WBack",3);

	m_Option.WPosX		= cOptionParser.GetOptionBool(L"WPos",1);
	m_Option.WPosY		= cOptionParser.GetOptionBool(L"WPos",2);
	m_Option.WSizeX		= cOptionParser.GetOptionBool(L"WPos",3);
	m_Option.WSizeY		= cOptionParser.GetOptionBool(L"WPos",4);

	m_Option.FDest		= cOptionParser.GetOptionString(L"FDest");

	m_Option.CPack		= cOptionParser.GetOptionBool(L"CPack");
}

void CDumpText::SaveOption()
{
	//ɼ 
	//OptionFileParser ̿Ѵ.
	CFileOptionParser cOptionParser(L"ATData\\DumpText.dat");

	cOptionParser.SetOptionInt(L"W",1,m_Option.WUse);
	cOptionParser.SetOptionInt(L"W",2,m_Option.WJpnText);
	cOptionParser.SetOptionInt(L"W",3,m_Option.WJpnHex);
	cOptionParser.SetOptionInt(L"W",4,m_Option.WKorText);
	cOptionParser.SetOptionInt(L"W",5,m_Option.WKorHex);

	cOptionParser.SetOptionInt(L"F",1,m_Option.FUse);
	cOptionParser.SetOptionInt(L"F",2,m_Option.FJpnText);
	cOptionParser.SetOptionInt(L"F",3,m_Option.FJpnHex);
	cOptionParser.SetOptionInt(L"F",4,m_Option.FKorText);
	cOptionParser.SetOptionInt(L"F",5,m_Option.FKorHex);

	cOptionParser.SetOptionInt(L"C",1,m_Option.CUse);
	cOptionParser.SetOptionInt(L"C",2,m_Option.CJpnText);
	cOptionParser.SetOptionInt(L"C",3,m_Option.CJpnHex);
	cOptionParser.SetOptionInt(L"C",4,m_Option.CKorText);
	cOptionParser.SetOptionInt(L"C",5,m_Option.CKorHex);

	cOptionParser.SetOptionInt(L"WNew",m_Option.WNew);
	cOptionParser.SetOptionInt(L"WTop",m_Option.WTop);

	cOptionParser.SetOptionString(L"LWFontFace",m_Option.WFontFace);

	cOptionParser.SetOptionInt(L"WFont",1,m_Option.WFont_R);
	cOptionParser.SetOptionInt(L"WFont",2,m_Option.WFont_G);
	cOptionParser.SetOptionInt(L"WFont",3,m_Option.WFont_B);

	cOptionParser.SetOptionInt(L"WBack",1,m_Option.WBack_R);
	cOptionParser.SetOptionInt(L"WBack",2,m_Option.WBack_G);
	cOptionParser.SetOptionInt(L"WBack",3,m_Option.WBack_B);

	cOptionParser.SetOptionInt(L"WPos",1,m_Option.WPosX);
	cOptionParser.SetOptionInt(L"WPos",2,m_Option.WPosY);
	cOptionParser.SetOptionInt(L"WPos",3,m_Option.WSizeX);
	cOptionParser.SetOptionInt(L"WPos",4,m_Option.WSizeY);

	cOptionParser.SetOptionInt(L"CPack",m_Option.CPack);

	cOptionParser.SetOptionString(L"FDest",m_Option.FDest);

	cOptionParser.SaveOptionFile();
}