#include "StdAfx.h"
#include "FileOptionParser.h"

#include "Util.h"

CFileOptionParser::CFileOptionParser(tstring strFileName=L"", bool AutoRead=false)
{
	if(strFileName.size>0)
		SetOptionFile(strFileName);

	if(strFileName.size>0 && AutoRead)
		OpenOptionFile();
		
}

CFileOptionParser::~CFileOptionParser(void)
{
}

// ϸ 
// ε 
void CFileOptionParser::SetOptionFile(tstring strFileName)
{
	//  Ȯ
	//̺  :  
	if(strFileName.find(_T(':'))!=strFileName.npos)
	{
		//ζ
		m_strFileName=strFileName;
	}
	else
	{
		//ζ
		//  
		m_strFileName = GetGameDirectory();
		m_strFileName += _T('\\');
		m_strFileName += strFileName;
	}
}

// 
void CFileOptionParser::OpenOptionFile()
{
	m_Options.clear();

	FILE * pFile;	// 

#ifdef _UNICODE
	_tfopen_s(&pFile,m_strFileName.c_str(),_T("rt,ccs=UTF-16LE"));	//UTF-16LE
#else
	_tfopen_s(&pFile,m_strFileName.c_str(),_T("rt"));			//MBCS
#endif

	if(pFile)
	{
		TCHAR szTempLine[1024]=_T("\0");	//  ӽ 

		while(_fgetts(szTempLine,1024,pFile))
		{
			size_t nLen = _tcslen(szTempLine);

			// ޺κ 
			if(szTempLine[nLen-1]==_T('\n'))
				szTempLine[--nLen]=_T('\0');

			tstring strTempLine=szTempLine;
			tstring strOptionName;			//ɼǸ
			tstring strOptionData;			//ɼǰ

			tstring::size_type nDivider=strTempLine.find(_T('='));

			if(nDivider!=strTempLine.npos)
			{
				strOptionName = RemoveSpace(strTempLine.substr(0,nDivider));
				strOptionData = RemoveSpace(strTempLine.substr(nDivider,nLen-nDivider-1));

				m_Options[strOptionName] = strOptionData;
			}

		} // while End

		fclose(pFile);

	} // pFile End
}

void CFileOptionParser::SaveOptionFile()
{
	FILE * pFile;

#ifdef _UNICODE
	_tfopen_s(&pFile,m_strFileName.c_str(),_T("wt,ccs=UTF-16LE"));	//UTF-16LE
#else
	_tfopen_s(&pFile,m_strFileName.c_str(),_T("wt"));			//MBCS
#endif

	if(pFile)
	{
		map <tstring,tstring>::iterator iter=m_Options.begin();

		while(iter!=m_Options.end())
		{
			_ftprintf(pFile,_T("%s=%s\n"),iter->first,iter->second);
			iter++;
		}

		fclose(pFile);
	}

}

int CFileOptionParser::GetOptionInt(tstring strOptionName, int nOptionSub)
{
	tstring strTemp=strOptionName;

	TCHAR szTemp[10]=_T("\0");
	_itot_s(nOptionSub,szTemp,10,10);

	strTemp += szTemp;

	return GetOptionInt(strTemp);
}

int CFileOptionParser::GetOptionInt(tstring strOptionName)
{
	int nReturnData=0;

	tstring strOptionData;

	if(m_Options.find(strOptionName)!=m_Options.end())
	{
		strOptionData = m_Options[strOptionName];

		nReturnData=0;

		int nLen = (int)strOptionData.length();
		int i=0;
		int PlusFlag=1;
		if(strOptionData[0]==_T('-'))
		{
			i=1;
			PlusFlag=-1;
		}
		else if(strOptionData[0]==_T('+'))
		{
			i=1;
			PlusFlag=1;
		}
		for(int i=0;i<nLen;i++)
		{
			int N=strOptionData[i] - _T('0');
			if(0<=N&&N<=9)
			{
				nReturnData *= 10;
				nReturnData += strOptionData[i] - _T('0');
			}
			else
				break;
		}
	}

	return nReturnData;
}

bool CFileOptionParser::GetOptionBool(tstring strOptionName)
{
	if(GetOptionInt(strOptionName))!=0)
		return true;
	else
		return false;
}

bool CFileOptionParser::GetOptionBool(tstring strOptionName, int nOptionSub)
{
	if(GetOptionInt(strOptionName,nOptionSub))!=0)
		return true;
	else
		return false;
}

tstring CFileOptionParser::GetOptionString(tstring strOptionName, int nOptionSub)
{
	tstring strTemp=strOptionName;

	TCHAR szTemp[10]=_T("\0");
	_itot_s(nOptionSub,szTemp,10,10);

	strTemp += szTemp;

	return GetOptionString(strTemp);
}

tstring CFileOptionParser::GetOptionString(tstring strOptionName)
{
	tstring strOptionData;

	if(m_Options.find(strOptionName)!=m_Options.end())
		strOptionData = m_Options[strOptionName];

	return strOptionData;
}

void CFileOptionParser::SetOptionInt(tstring strOptionName, int nOptionSub, int nOptionData)
{
	tstring strTemp=strOptionName;

	TCHAR szTemp[10]=_T("\0");
	_itot_s(nOptionSub,szTemp,10,10);

	strTemp += szTemp;

	SetOptionInt(strTemp,nOptionData);
}

void CFileOptionParser::SetOptionInt(tstring strOptionName, int nOptionData)
{
	TCHAR szOptionData[10] = _T("\0");

	_itot_s(nOptionData,szOptionData,10,10);

	m_Options[strOptionName] = tstring(szOptionData);
}

void CFileOptionParser::SetOptionString(tstring strOptionName, int nOptionSub, tstring strOptionData)
{
	tstring strTemp=strOptionName;

	TCHAR szTemp[10]=_T("\0");
	_itot_s(nOptionSub,szTemp,10,10);

	strTemp += szTemp;

	SetOptionString(strTemp,strOptionData);
}

void CFileOptionParser::SetOptionString(tstring strOptionName, tstring strOptionData)
{
	m_Options[strOptionName] = strOptionData;
}

tstring CFileOptionParser::RemoveSpace(tstring strData)
{
	tstring::size_type nHead;
	tstring::size_type nTail;

	nHead = strData.find_first_not_of(_T(' '));
	nTail = strData.find_last_not_of(_T(' '));

	return strData.substr(nHead,nTail-nHead+1);
}